
#include "sound_effect.h"
#include "mathf.h"

static void IIR_resonator(float fc, float Q, float a[], float b[])
{
  fc = tanf(M_PI * fc) / (2.0 * M_PI);

  a[0] = 1.0 + 2.0 * M_PI * fc / Q + 4.0 * M_PI * M_PI * fc * fc;
  a[1] = (8.0 * M_PI * M_PI * fc * fc - 2.0) / a[0];
  a[2] = (1.0 - 2.0 * M_PI * fc / Q + 4.0 * M_PI * M_PI * fc * fc) / a[0];
  b[0] = 2.0 * M_PI * fc / Q / a[0];
  b[1] = 0.0;
  b[2] = -2.0 * M_PI * fc / Q / a[0];

  a[0] = 1.0;
}

void wah(int offset, int data_handling_size)
{
	int n;
	short volume1 = g_ad_val[0], volume2 = g_ad_val[1], volume3 = g_ad_val[2];
	int m;
	float depth, rate;
	float delta, x = 0.0;
	float fc, Q, a[3], b[3], s0[128 + 2], s1[128 + 2];

	depth = (float)volume1 / 4096.0 * 800.0;
	rate = (float)volume2 / 4096.0 * 2.0;

	for (n = 0; n < data_handling_size + 2; n++)
	{
		m = offset - 2 + n;
		if (m < 0)
		{
			m += DATA_BUFFER_SIZE;
		}
		s0[n] = g_pcm0[m].ch0;
	}

	for (n = 0; n < 2; n++)
	{
		m = offset - 2 + n;
		if (m < 0)
		{
			m += DATA_BUFFER_SIZE;
		}
		s1[n] = g_pcm1[m].ch0;
	}
	
	for (n = 2; n < data_handling_size + 2; n++)
	{
		s1[n] = 0.0;
	}

	for (n = 0; n < data_handling_size; n++)
	{
		fc = 1000.0	+ depth * sinf(2.0 * M_PI * x);

		delta = rate / FS;
		x += delta;
		if (x >= 1.0)
		{
			x -= 1.0;
		}

		Q = 2.0;

		IIR_resonator(fc / FS, Q, a, b);

		for (m = 0; m <= 2; m++)
		{
			s1[2 + n] += b[m] * s0[2 + n - m];
		}
		
		for (m = 1; m <= 2; m++)
		{
			s1[2 + n] += -a[m] * s1[2 + n - m];
		}
	}

	for (n = 0; n < data_handling_size; n++)
	{
		g_pcm1[offset + n].ch0 = s1[2 + n];
	}
}
